<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: SEO Friendly URLs for PHP-Fusion
| Filename: SEO_Functions.php
| Version: 1.00
| Author: Ankur Thakur
| Developers: Ankur Thakur
| Web : http://ankurthakur.co.cc/
|       http://php-fusion.in/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

/*----------+
|   USERS   |
+----------*/
function replace_users($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Profile-".$matches[2]."-".cleanmytext($data_cache['users'][$matches[2]]).URL_POSTFIX."'";
	return $replace;
}

/*-----------+
|   GROUPS   |
+-----------*/
function replace_groups($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Group-".$matches[2]."-".cleanmytext($data_cache['groups'][$matches[2]]).URL_POSTFIX."'";
	return $replace;
}

/*-----------------+
|   CUSTOM PAGES   |
+-----------------*/
function replace_custom_pages($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Page-".$matches[2].((array_key_exists(4, $matches) && substr($matches[4], 9) !=0) ? "-rowstart-".substr($matches[4], 9)."-" : "-").cleanmytext($data_cache['custom_pages'][$matches[2]]).URL_POSTFIX.(array_key_exists(5, $matches) ? $matches[5] : "")."'";
	return $replace;
}

/*-----------+
|    NEWS    |
+-----------*/
function replace_news($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."News-".$matches[2].((array_key_exists(4, $matches) && substr($matches[4], 8) !=0) ? "-commentstart-".substr($matches[4], 8)."-" : "-").cleanmytext($data_cache['news'][$matches[2]]).URL_POSTFIX.(array_key_exists(6, $matches) ? $matches[6] : "").(array_key_exists(5, $matches) ? $matches[5] : "")."'";
	return $replace;
}

/*--------------+
|   NEWS CATS   |
+--------------*/
function replace_news_cats($matches)
{
	global $data_cache, $locale;
	if ($matches[2] == 0)	{
		$replace = "'".$matches[1]."News-Category-".$matches[2]."-".cleanmytext($locale['global_080']).URL_POSTFIX."'";	// $locale['global_080'] = Uncategorised
	}
	else	{
		$replace = "'".$matches[1]."News-Category-".$matches[2]."-".cleanmytext($data_cache['news_cats'][$matches[2]]).URL_POSTFIX."'";
	}
	return $replace;
}

/*-------------+
|   ARTICLES   |
+-------------*/
function replace_articles($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Article-".$matches[2].((array_key_exists(4, $matches) && substr($matches[4], 8) != 0) ? "-commentstart-".substr($matches[4], 8)."-" : "-").cleanmytext($data_cache['articles'][$matches[2]]).URL_POSTFIX.(array_key_exists(5, $matches) ? $matches[5] : "")."'";
	return $replace;
}

/*-----------------+
|   ARTICLE CATS   |
+-----------------*/
function replace_articles_cats($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Article-Category-".$matches[2].(array_key_exists(4, $matches) ? "-rowstart-".substr($matches[4], 9)."-" : "-").cleanmytext($data_cache['articles_cats'][$matches[2]]).URL_POSTFIX."'";
	return $replace;
}

/*--------------+
|   DOWNLOADS   |
+--------------*/
function replace_downloads($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Download-".$matches[4]."-".cleanmytext($data_cache['downloads'][$matches[4]]).URL_POSTFIX.(array_key_exists(5, $matches) ? $matches[5] : "")."'";
	return $replace;
}

/*-------------------+
|   DOWNLOADS CATS   |
+-------------------*/
function replace_downloads_cats($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Download-Category-".$matches[2]."-".cleanmytext($data_cache['downloads_cats'][$matches[2]]).URL_POSTFIX."'";
	return $replace;
}

/*-----------------+
|   PHOTO-ALBUMS   |
+-----------------*/
function replace_photoalbums($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Photogallery-Album-".$matches[2].(array_key_exists(3, $matches) ? "-".substr($matches[3], 14)."-" : "-").cleanmytext($data_cache['photo_albums'][$matches[2]]).URL_POSTFIX."'";
	return $replace;
}

/*-----------+
|   PHOTOS   |
+-----------*/
function replace_photos($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Photo-".$matches[2]."-".cleanmytext($data_cache['photos'][$matches[2]]).URL_POSTFIX.(array_key_exists(3, $matches) ? $matches[3] : "")."'";
	return $replace;
}

/*-------------+
|   WEBLINKS   |
+-------------*/
function replace_weblinks($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Weblink-".$matches[4]."-".cleanmytext($data_cache['weblinks'][$matches[4]]).URL_POSTFIX."'";
	return $replace;
}

/*------------------+
|   WEBLINKS CATS   |
+------------------*/
function replace_weblinks_cats($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."Weblinks-Category-".$matches[2].(array_key_exists(4, $matches) ? "-rowstart-".substr($matches[4], 9)."-" : "-").cleanmytext($data_cache['weblinks_cats'][$matches[2]]).URL_POSTFIX."'";
	return $replace;
}

/*------------+
|   THREADS   |
+------------*/
function replace_threads($matches)
{
	global $data_cache;
	$replace = "'".$matches[1].$matches[2]."Thread-".$matches[3].((array_key_exists(5, $matches) && substr($matches[5], 4) != "") ? "-Post-".substr($matches[5], 4) : "").((array_key_exists(6, $matches) && (substr($matches[6], 9) != 0)) ? "-rowstart-".substr($matches[6], 9) : "")."-".cleanmytext($data_cache['threads'][$matches[3]]).URL_POSTFIX.(array_key_exists(7, $matches) ? $matches[7] : "")."'";
	return $replace;
}

/*-----------+
|   FORUMS   |
+-----------*/
function replace_forums($matches)
{
	global $data_cache;
	$replace = "'".$matches[1].$matches[2]."Forum-".$matches[3].(array_key_exists(4, $matches) ? "-rowstart-".substr($matches[4], 14)."-" : "-").cleanmytext($data_cache['forums'][$matches[3]]).URL_POSTFIX."'";
	return $replace;
}

/*-------------+
|   FAQ CATS   |
+-------------*/
function replace_faqs_cats($matches)
{
	global $data_cache;
	$replace = "'".$matches[1]."FAQ-Category-".$matches[2]."-".cleanmytext($data_cache['faqs_cats'][$matches[2]]).URL_POSTFIX.(array_key_exists(3, $matches) ? $matches[3] : "")."'";
	return $replace;
}

/*----------------+
|   SUBMISSIONS   |
+----------------*/
function replace_submissions($matches)
{
	if ($matches[2] == "p")	{
		$replace = "'".$matches[1]."Submit-Photo".URL_POSTFIX."'";
	}
	if ($matches[2] == "a")	{
		$replace = "'".$matches[1]."Submit-Article".URL_POSTFIX."'";
	}
	if ($matches[2] == "n")	{
		$replace = "'".$matches[1]."Submit-News".URL_POSTFIX."'";
	}
	if ($matches[2] == "l")	{
		$replace = "'".$matches[1]."Submit-Link".URL_POSTFIX."'";
	}
	if ($matches[2] == "d")	{
		$replace = "'".$matches[1]."Submit-Download".URL_POSTFIX."'";
	}
	return $replace;
}

/*-------------+
|   MESSAGES   |
+-------------*/
function replace_messages($matches)
{
	if ($matches[2] == "inbox")	{
		$replace = "'".$matches[1]."Messages-Inbox".URL_POSTFIX."'";
	}
	if ($matches[2] == "outbox")	{
		$replace = "'".$matches[1]."Messages-Outbox".URL_POSTFIX."'";
	}
	if ($matches[2] == "archive")	{
		$replace = "'".$matches[1]."Messages-Archive".URL_POSTFIX."'";
	}
	if ($matches[2] == "options")	{
		$replace = "'".$matches[1]."Messages-Options".URL_POSTFIX."'";
	}
	return $replace;
}

/*-----------------+
|   MEMBERS LIST   |
+-----------------*/
function replace_members_list($matches)
{
	$replace = "'".$matches[1]."Members-Sortby-".$matches[2].(array_key_exists(3, $matches) ? "-rowstart-".substr($matches[3], 14) : "").URL_POSTFIX."'";
	return $replace;
}

/*-----------------+
|   NORMAL PAGES   |
+-----------------*/
function replace_normal_pages($matches)
{
	$replace = "'".$matches[1].ucfirst($matches[2]).URL_POSTFIX."'";
	return $replace;
}

/*----------------+
|   PRINT PAGES   |
+----------------*/
function replace_print_pages($matches)
{
	global $data_cache;

	if ($matches[2] == "N")	{
		$replace = "'".$matches[1]."Print-News-".substr($matches[4], 8)."-".cleanmytext($data_cache['news'][substr($matches[4], 8)]).URL_POSTFIX."'";
	}
	if ($matches[2] == "A")	{
		$replace = "'".$matches[1]."Print-Article-".substr($matches[4], 8)."-".cleanmytext($data_cache['articles'][substr($matches[4], 8)]).URL_POSTFIX."'";
	}
	if ($matches[2] == "F")	{
		$replace = "'".$matches[1]."Print-Thread-".substr($matches[5], 7).((array_key_exists(7, $matches) && substr($matches[7], 5) != 0) ? "-Post-".substr($matches[7], 5) : "").((array_key_exists(9, $matches) && substr($matches[9], 3)) ? "-nr-".substr($matches[9], 3) : "")."-".cleanmytext($data_cache['threads'][substr($matches[5], 7)]).URL_POSTFIX."'";
	}
	if ($matches[2] == "T")	{
		$replace = "'".$matches[1]."Terms-of-Agreement".URL_POSTFIX."'";
	}
	return $replace;
}

?>