<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: SEO Friendly URLs for PHP-Fusion
| Filename: seo_friendly_urls_panel.php
| Version: 1.00
| Author: Ankur Thakur
| Developers: Ankur Thakur
| Web : http://ankurthakur.co.cc/
|       http://php-fusion.in/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

//---------------------------------------------------------------------//
//-------------------- Fetching Database Settings --------------------//
//-------------------------------------------------------------------//

// Database Settings
// Fetching Database Settings
$seosettings = array();
$result = dbquery("SELECT * FROM ".DB_SETTINGS_INF." WHERE settings_inf='seo_friendly_urls_panel'");
if (dbrows($result)) {
	while ($data = dbarray($result)) {
		$seosettings[$data['settings_name']] = $data['settings_value'];
	}
}

// Execute Only if SEO is Enabled
if ($seosettings['seo_urls_enabled'] == 1)
{

//--------------------------------------------------------------------------------------------------------//
//------------------------------------------- SEO URL Type ----------------------------------------------//
//------------------------------------------------------------------------------------------------------//

define("URL_POSTFIX", $seosettings['seo_urls_type'] == "html" ? ".html" : "");

//--------------------------------------------------------------------------------------------------------//
//--------------------------------- Function to Clean Text for SEO URL ----------------------------------//
//------------------------------------------------------------------------------------------------------//
function cleanmytext($text)
{
	$text = preg_replace("/[^a-zA-Z0-9_-\s]/", "", $text);
	$text = str_replace(" ", "-", $text);
	$text = preg_replace("/([\s\s]+|[--]+)/", "-", $text);
	return $text;
}

//--------------------------------------------------------------------------------------------------------//
//----------- Variables to Store Data related to Users, Threads, Forums, News, Articles etc -------------//
//------------------------------------------------------------------------------------------------------//

// This will Hold the Details on the IDs which will be retrieved using Query
$data_cache = array(
"users" => array(),
"groups" => array(),
"custom_pages" => array(),
"news" => array(),
"news_cats" => array(),
"articles" => array(),
"articles_cats" => array(),
"downloads" => array(),
"downloads_cats" => array(),
"faqs_cats" => array(),
"forums" => array(),
"threads" => array(),
"photos" => array(),
"photo_albums" => array(),
"weblinks" => array(),
"weblinks_cats" => array()
);
// This will Hold the IDs on the current page
$id_cache = array(
"users" => array(),
"groups" => array(),
"custom_pages" => array(),
"news" => array(),
"news_cats" => array(),
"articles" => array(),
"articles_cats" => array(),
"downloads" => array(),
"downloads_cats" => array(),
"faqs_cats" => array(),
"forums" => array(),
"threads" => array(),
"photos" => array(),
"photo_albums" => array(),
"weblinks" => array(),
"weblinks_cats" => array()
);

//--------------------------------------------------------------------------------------------------------//
//-------------------------- Main Handler for Output Replacement Start here -----------------------------//
//------------------------------------------------------------------------------------------------------//

function seo_url_handler($output)
{

global $settings, $data_cache, $id_cache;

//--------------------------------------------------------------------------------------------------------//
//--------------- Adding Backslashes in the Forward-slashes and Dots in BASEDIR for REGEX ---------------//
//------------------------------------------------------------------------------------------------------//

// Changing Forward Slash (/) to Back+Forward Slash (\/) for REGEX
// Changing Dot (.) to BackSlash Dot (\.) for REGEX
$linkpath = preg_replace("/\./", "\.", preg_replace("/\//", "\/", BASEDIR));

// Site URL
$siteurl = preg_replace("/\./", "\.", preg_replace("/\//", "\/", $settings['siteurl']));

//------------------------------------------------------------------------------------------------------//
//------------------------ Searching of unique IDs into $matches arrays -------------------------------//
//----------------------------------------------------------------------------------------------------//

/*----------+
|   USERS   |
+----------*/
// Find the IDs of Users on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?profile\.php\?lookup=([0-9]+)'/", $output, $users_matches);
// Add them into the Cache of IDs for Users
$id_cache['users'] = array_unique($users_matches[2]);

/*-----------+
|   GROUPS   |
+-----------*/
// Find the IDs of Groups on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?profile\.php\?group_id=([0-9]+)'/", $output, $groups_matches);
// Add them into the Cache of IDs for Groups
$id_cache['groups'] = array_unique($groups_matches[2]);

/*-----------------+
|   CUSTOM PAGES   |
+-----------------*/
// Find the IDs of Custom Pages on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?viewpage\.php\?page_id=([0-9]+)(#c[0-9]+)?'/", $output, $custom_pages_matches);
// Add them into the Cache of IDs for Custom Pages
$id_cache['custom_pages'] = array_unique($custom_pages_matches[2]);

/*-----------+
|    NEWS    |
+-----------*/
// Find the IDs of News on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?news\.php\?readmore=([0-9]+)(#comments)?(#c[0-9]+)?'/", $output, $news_matches);
// Add them into the Cache of IDs for News
$id_cache['news'] = array_unique($news_matches[2]);

/*--------------+
|   NEWS CATS   |
+--------------*/
// Find the IDs of News Categories on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?news_cats\.php\?cat_id=([0-9]+)'/", $output, $news_cats_matches);
// Add them into the Cache of IDs for News Categories
$id_cache['news_cats'] = array_unique($news_cats_matches[2]);

/*-------------+
|   ARTICLES   |
+-------------*/
// Find the IDs of Articles on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?articles\.php\?article_id=([0-9]+)(#c[0-9]+)?'/", $output, $articles_matches);
// Add them into the Cache of IDs for Articles
$id_cache['articles'] = array_unique($articles_matches[2]);

/*-----------------+
|   ARTICLE CATS   |
+-----------------*/
// Find the IDs of Articles Categories on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?articles\.php\?cat_id=([0-9]+)'/", $output, $articles_cats_matches);
// Add them into the Cache of IDs for News Categories
$id_cache['articles_cats'] = array_unique($articles_cats_matches[2]);

/*--------------+
|   DOWNLOADS   |
+--------------*/
// Find the IDs of Downloads on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?downloads\.php\?(cat_id=[0-9]+)?(\&amp\;)?download_id=([0-9]+){1}(#c[0-9]+)?'/", $output, $downloads_matches);
// Add them into the Cache of IDs for Downloads
$id_cache['downloads'] = array_unique($downloads_matches[4]);

/*-------------------+
|   DOWNLOADS CATS   |
+-------------------*/
// Find the IDs of Downloads Cats on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?downloads\.php\?cat_id=([0-9]+){1}(\&amp\;)?(download_id=[0-9]+)?'/", $output, $downloads_cats_matches);
// Add them into the Cache of IDs for Downloads
$id_cache['downloads_cats'] = array_unique($downloads_cats_matches[2]);

/*-----------------+
|   PHOTO-ALBUMS   |
+-----------------*/
// Find the IDs of Photo Albums on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?photogallery\.php\?album_id=([0-9]+)(\&amp\;rowstart=[0-9]+)?'/", $output, $photoalbums_matches);
// Add them into the Cache of IDs for Photo Albums
$id_cache['photo_albums'] = array_unique($photoalbums_matches[2]);

/*-----------+
|   PHOTOS   |
+-----------*/
// Find the IDs of Photos on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?photogallery\.php\?photo_id=([0-9]+)(#c[0-9]+)?'/", $output, $photos_matches);
// Add them into the Cache of IDs for Photos
$id_cache['photos'] = array_unique($photos_matches[2]);

/*-------------+
|   WEBLINKS   |
+-------------*/
// Find the IDs of Web-Links on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?weblinks\.php\?(cat_id=[0-9]+)?(\&amp\;)?weblink_id=([0-9]+){1}'/", $output, $weblinks_matches);
// Add them into the Cache of IDs for Web-Links
$id_cache['weblinks'] = array_unique($weblinks_matches[4]);

/*------------------+
|   WEBLINKS CATS   |
+------------------*/
// Find the IDs of Web-Links Cats on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?weblinks\.php\?cat_id=([0-9]+){1}'/", $output, $weblinks_cats_matches);
// Add them into the Cache of IDs for Web-Links Cats
$id_cache['weblinks_cats'] = array_unique($weblinks_cats_matches[2]);

/*------------+
|   THREADS   |
+------------*/
// Find the IDs of Threads on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?(forum\/)?viewthread\.php\?thread_id=([0-9]+)(\&amp\;)?(pid=[0-9]+)?(rowstart=[0-9]+)?(#post_[0-9]+)?'/", $output, $threads_matches);
// Add them into the Cache of IDs for Threads
$id_cache['threads'] = array_unique($threads_matches[3]);

/*-----------+
|   FORUMS   |
+-----------*/
// Find the IDs of Forums on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?(forum\/)?viewforum\.php\?forum_id=([0-9]+)(\&amp\;rowstart=[0-9]+)?'/", $output, $forums_matches);
// Add them into the Cache of IDs for Forums
$id_cache['forums'] = array_unique($forums_matches[3]);

/*-------------+
|   FAQ CATS   |
+-------------*/
// Find the IDs of FAQs Cats on the current Page
preg_match_all("/'(".$linkpath."|".$siteurl.")?faq\.php\?cat_id=([0-9]+){1}(#[a-zA-Z0-9_-])?'/", $output, $faqs_cats_matches);
// Add them into the Cache of IDs for Web-Links
$id_cache['faqs_cats'] = array_unique($faqs_cats_matches[2]);

//-------------------------------------------------------------------------------------------------------------//
//-------------------- Fetching Titles/Subjects of News, Articles, Forums etc into Arrays --------------------//
//-----------------------------------------------------------------------------------------------------------//

/*----------+
|   USERS   |
+----------*/
if (!empty($id_cache['users']))	{
	$result = dbquery("SELECT user_id, user_name FROM ".DB_USERS." WHERE user_id IN(".implode(",", $id_cache['users']).")");
	while($data = dbarray($result))
	{
		$data_cache['users'][$data['user_id']] = $data['user_name'];
	}
}
/*-----------+
|   GROUPS   |
+-----------*/
if (!empty($id_cache['groups']))	{
	$result = dbquery("SELECT group_id, group_name FROM ".DB_USER_GROUPS." WHERE group_id IN(".implode(",", $id_cache['groups']).")");
	while($data = dbarray($result))
	{
		$data_cache['groups'][$data['group_id']] = $data['group_name'];
	}
}
/*-----------------+
|   CUSTOM PAGES   |
+-----------------*/
if (!empty($id_cache['custom_pages']))	{
	$result = dbquery("SELECT page_id, page_title FROM ".DB_CUSTOM_PAGES." WHERE page_id IN(".implode(",", $id_cache['custom_pages']).")");
	while($data = dbarray($result))
	{
		$data_cache['custom_pages'][$data['page_id']] = $data['page_title'];
	}
}
/*-----------+
|    NEWS    |
+-----------*/
if (!empty($id_cache['news']))	{
	$result = dbquery("SELECT news_id, news_subject FROM ".DB_NEWS." WHERE news_id IN(".implode(",", $id_cache['news']).")");
	while($data = dbarray($result))
	{
		$data_cache['news'][$data['news_id']] = $data['news_subject'];
	}
}
/*--------------+
|   NEWS CATS   |
+--------------*/
if (!empty($id_cache['news_cats']))	{
	$result = dbquery("SELECT news_cat_id, news_cat_name FROM ".DB_NEWS_CATS." WHERE news_cat_id IN(".implode(",", $id_cache['news_cats']).")");
	while($data = dbarray($result))
	{
		$data_cache['news_cats'][$data['news_cat_id']] = $data['news_cat_name'];
	}
}
/*-------------+
|   ARTICLES   |
+-------------*/
if (!empty($id_cache['articles']))	{
	$result = dbquery("SELECT article_id, article_subject FROM ".DB_ARTICLES." WHERE article_id IN(".implode(",", $id_cache['articles']).")");
	while($data = dbarray($result))
	{
		$data_cache['articles'][$data['article_id']] = $data['article_subject'];
	}
}
/*-----------------+
|   ARTICLE CATS   |
+-----------------*/
if (!empty($id_cache['articles_cats']))	{
	$result = dbquery("SELECT article_cat_id, article_cat_name FROM ".DB_ARTICLE_CATS." WHERE article_cat_id IN(".implode(",", $id_cache['articles_cats']).")");
	while($data = dbarray($result))
	{
		$data_cache['articles_cats'][$data['article_cat_id']] = $data['article_cat_name'];
	}
}
/*--------------+
|   DOWNLOADS   |
+--------------*/
if (!empty($id_cache['downloads']))	{
	$result = dbquery("SELECT download_id, download_title FROM ".DB_DOWNLOADS." WHERE download_id IN(".implode(",", $id_cache['downloads']).")");
	while($data = dbarray($result))
	{
		$data_cache['downloads'][$data['download_id']] = $data['download_title'];
	}
}
/*-------------------+
|   DOWNLOADS CATS   |
+-------------------*/
if (!empty($id_cache['downloads_cats']))	{
	$result = dbquery("SELECT download_cat_id, download_cat_name FROM ".DB_DOWNLOAD_CATS." WHERE download_cat_id IN(".implode(",", $id_cache['downloads_cats']).")");
	while($data = dbarray($result))
	{
		$data_cache['downloads_cats'][$data['download_cat_id']] = $data['download_cat_name'];
	}
}
/*-----------------+
|   PHOTO-ALBUMS   |
+-----------------*/
if (!empty($id_cache['photo_albums']))	{
	$result = dbquery("SELECT album_id, album_title FROM ".DB_PHOTO_ALBUMS." WHERE album_id IN(".implode(",", $id_cache['photo_albums']).")");
	while($data = dbarray($result))
	{
		$data_cache['photo_albums'][$data['album_id']] = $data['album_title'];
	}
}
/*-----------+
|   PHOTOS   |
+-----------*/
if (!empty($id_cache['photos']))	{
	$result = dbquery("SELECT photo_id, photo_title FROM ".DB_PHOTOS." WHERE photo_id IN(".implode(",", $id_cache['photos']).")");
	while($data = dbarray($result))
	{
		$data_cache['photos'][$data['photo_id']] = $data['photo_title'];
	}
}
/*-------------+
|   WEBLINKS   |
+-------------*/
if (!empty($id_cache['weblinks']))	{
	$result = dbquery("SELECT weblink_id, weblink_name FROM ".DB_WEBLINKS." WHERE weblink_id IN(".implode(",", $id_cache['weblinks']).")");
	while($data = dbarray($result))
	{
		$data_cache['weblinks'][$data['weblink_id']] = $data['weblink_name'];
	}
}
/*------------------+
|   WEBLINKS CATS   |
+------------------*/
if (!empty($id_cache['weblinks_cats']))	{
	$result = dbquery("SELECT weblink_cat_id, weblink_cat_name FROM ".DB_WEBLINK_CATS." WHERE weblink_cat_id IN(".implode(",", $id_cache['weblinks_cats']).")");
	while($data = dbarray($result))
	{
		$data_cache['weblinks_cats'][$data['weblink_cat_id']] = $data['weblink_cat_name'];
	}
}
/*------------+
|   THREADS   |
+------------*/
if (!empty($id_cache['threads']))	{
	$result = dbquery("SELECT thread_id, thread_subject FROM ".DB_THREADS." WHERE thread_id IN(".implode(",", $id_cache['threads']).")");
	while($data = dbarray($result))
	{
		$data_cache['threads'][$data['thread_id']] = $data['thread_subject'];
	}
}
/*-----------+
|   FORUMS   |
+-----------*/
if (!empty($id_cache['forums']))	{
	$result = dbquery("SELECT forum_id, forum_name FROM ".DB_FORUMS." WHERE forum_id IN(".implode(",", $id_cache['forums']).")");
	while($data = dbarray($result))
	{
		$data_cache['forums'][$data['forum_id']] = $data['forum_name'];
	}
}
/*-------------+
|   FAQ CATS   |
+-------------*/
if (!empty($id_cache['faqs_cats']))	{
	$result = dbquery("SELECT faq_cat_id, faq_cat_name FROM ".DB_FAQ_CATS." WHERE faq_cat_id IN(".implode(",", $id_cache['faqs_cats']).")");
	while($data = dbarray($result))
	{
		$data_cache['faqs_cats'][$data['faq_cat_id']] = $data['faq_cat_name'];
	}
}

//------------------------------------------------------------------------------------------------------//
//---------------------------------- Functions to return the SEO URL ----------------------------------//
//----------------------------------------------------------------------------------------------------//
include INFUSIONS."seo_friendly_urls_panel/includes/seo_functions.php";

//------------------------------------------------------------------------------------------------------//
//---------------------- Calling Statements for Replacing the Pattern to SEO URL ----------------------//
//----------------------------------------------------------------------------------------------------//

/*----------+
|   USERS   |
+----------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?profile\.php\?lookup=([0-9]+)'/";
$output = preg_replace_callback($pattern, "replace_users", $output);

/*-----------+
|   GROUPS   |
+-----------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?profile\.php\?group_id=([0-9]+)'/";
$output = preg_replace_callback($pattern, "replace_groups", $output);

/*-----------------+
|   CUSTOM PAGES   |
+-----------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?viewpage\.php\?page_id=([0-9]+)(\&amp\;)?(rowstart=[0-9]+)?(#c[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_custom_pages", $output);

/*-----------+
|    NEWS    |
+-----------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?news\.php\?readmore=([0-9]+)(\&amp\;)?(c_start=[0-9]+)?(#comments)?(#c[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_news", $output);
// For News Rowstart (Page Navigation)
$pattern = "/'(".$linkpath."|".$siteurl.")?news\.php\?rowstart=([0-9]+)'/";
$output = preg_replace($pattern, "$1news-rowstart-$2".URL_POSTFIX, $output);

/*--------------+
|   NEWS CATS   |
+--------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?news_cats\.php\?cat_id=([0-9]+)'/";
$output = preg_replace_callback($pattern, "replace_news_cats", $output);
$pattern = "/'(".$linkpath."|".$siteurl.")?news_cats\.php\'/";
$output = preg_replace($pattern, "$1News-Categories".URL_POSTFIX, $output);

/*-------------+
|   ARTICLES   |
+-------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?articles\.php\?article_id=([0-9]+)(\&amp\;)?(c_start=[0-9]+)?(#c[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_articles", $output);

/*-----------------+
|   ARTICLE CATS   |
+-----------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?articles\.php\?cat_id=([0-9]+)(\&amp\;)?(rowstart=[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_articles_cats", $output);

/*--------------+
|   DOWNLOADS   |
+--------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?downloads\.php\?(cat_id=[0-9]+)?(\&amp\;)?download_id=([0-9]+){1}(#c[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_downloads", $output);

/*-------------------+
|   DOWNLOADS CATS   |
+-------------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?downloads\.php\?cat_id=([0-9]+){1}(\&amp\;)?(download_id=[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_downloads_cats", $output);

/*-----------------+
|   PHOTO-ALBUMS   |
+-----------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?photogallery\.php\?album_id=([0-9]+)(\&amp\;rowstart=[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_photoalbums", $output);

/*-----------+
|   PHOTOS   |
+-----------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?photogallery\.php\?photo_id=([0-9]+)(#c[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_photos", $output);

/*-------------+
|   WEBLINKS   |
+-------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?weblinks\.php\?(cat_id=[0-9]+)?(\&amp\;)?weblink_id=([0-9]+){1}'/";
$output = preg_replace_callback($pattern, "replace_weblinks", $output);

/*------------------+
|   WEBLINKS CATS   |
+------------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?weblinks\.php\?cat_id=([0-9]+){1}(\&amp\;)?(rowstart=[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_weblinks_cats", $output);

/*------------+
|   THREADS   |
+------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?(forum\/)?viewthread\.php\?thread_id=([0-9]+)(\&amp\;)?(pid=[0-9]+)?(rowstart=[0-9]+)?(#post_[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_threads", $output);

/*-----------+
|   FORUMS   |
+-----------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?(forum\/)?viewforum\.php\?forum_id=([0-9]+)(\&amp\;rowstart=[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_forums", $output);
// New Thread Link
$pattern = "/'(".$linkpath."|".$siteurl.")?(forum\/)?post\.php\?action=newthread\&amp\;forum_id=([0-9]+)'/";
$output = preg_replace($pattern, "$1$2New-Thread-$3".URL_POSTFIX, $output);

/*-------------+
|   FAQ CATS   |
+-------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?faq\.php\?cat_id=([0-9]+){1}(#[a-zA-Z0-9_-])?'/";
$output = preg_replace_callback($pattern, "replace_faqs_cats", $output);

/*----------------+
|   SUBMISSIONS   |
+----------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?submit\.php\?stype=(p|a|n|l|d)'/";
$output = preg_replace_callback($pattern, "replace_submissions", $output);

/*----------------+
|   MESSAGES   |
+----------------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?messages\.php\?folder=(inbox|outbox|archive|options)'/";
$output = preg_replace_callback($pattern, "replace_messages", $output);
// Write New Message
$pattern = "/'(".$linkpath."|".$siteurl.")?messages\.php\?msg_send=([0-9]+)'/";
$output = preg_replace($pattern, "$1Compose-Message-$2".URL_POSTFIX, $output);

/*-----------------+
|   MEMBERS LIST   |
+-----------------*/
// Sorting and Rowstart
$pattern = "/'(".$linkpath."|".$siteurl.")?members\.php\?sortby\=([a-zA-Z0-9_]+)(\&amp\;rowstart=[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_members_list", $output);

/*----------+
|   PRINT   |
+----------*/
$pattern = "/'(".$linkpath."|".$siteurl.")?print\.php\?type\=(F|A|N|T)(\&amp\;)?(item_id=[0-9]+)?(thread=[0-9]+)?(\&amp\;)?(post=[0-9]+)?(\&amp\;)?(nr=[0-9]+)?(\&amp\;)?(rowstart=[0-9]+)?'/";
$output = preg_replace_callback($pattern, "replace_print_pages", $output);

/*----------+
|   PAGES   |
+----------*/
// For Root Pages
$pattern = "/'(".$linkpath."|".$siteurl.")?([a-zA-Z0-9_-]+)\.php'/";
$output = preg_replace_callback($pattern, "replace_normal_pages", $output);
// For Forum Index
$pattern = "/'(".$linkpath."|".$siteurl.")?forum\/index\.php'/";
$output = preg_replace($pattern, "$1forum/index".URL_POSTFIX, $output);
// For Index/General Pages for Infusions
$pattern = "/'(".$linkpath."|".$siteurl.")?infusions\/([a-zA-Z0-9_-]+)\/(.*?)\.php'/";
$output = preg_replace($pattern, "$1infusions/$2/$3".URL_POSTFIX, $output);
// Log Out URL
$pattern = "/'(".$linkpath."|".$siteurl.")?index\.php\?logout=yes'/";
$output = preg_replace($pattern, "$1Logout".URL_POSTFIX, $output);

/*-----------------------------------------+
|   COMMENTS EDIT/DELETE LINKS DISCARDED   |
|             Case Insensitive             |
+-----------------------------------------*/
// For News
$pattern = "/'([^\']+)News-([0-9]+)-(.*?)(c_action=edit\&amp\;comment_id=[0-9]+\#edit_comment)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?readmore=$2&$4'", $output);
$pattern = "/'([^\']+)Article-([0-9]+)-(.*?)(c_action=delete\&amp\;comment_id=[0-9]+)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?article_id=$2&$4'", $output);
// For Articles
$pattern = "/'([^\']+)Article-([0-9]+)-(.*?)(c_action=edit\&amp\;comment_id=[0-9]+\#edit_comment)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?article_id=$2&$4'", $output);
$pattern = "/'([^\']+)Article-([0-9]+)-(.*?)(c_action=delete\&amp\;comment_id=[0-9]+)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?article_id=$2&$4'", $output);
// For Downloads
$pattern = "/'([^\']+)Download-([0-9]+)-(.*?)(c_action=edit\&amp\;comment_id=[0-9]+\#edit_comment)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?download_id=$2&$4'", $output);
$pattern = "/'([^\']+)Download-([0-9]+)-(.*?)(c_action=delete\&amp\;comment_id=[0-9]+)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?download_id=$2&$4'", $output);
// For Custom Pages
$pattern = "/'([^\']+)Page-([0-9]+)-(.*?)(c_action=edit\&amp\;comment_id=[0-9]+\#edit_comment)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?page_id=$2&$4'", $output);
$pattern = "/'([^\']+)Page-([0-9]+)-(.*?)(c_action=delete\&amp\;comment_id=[0-9]+)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?page_id=$2&$4'", $output);
// For Photos
$pattern = "/'([^\']+)Photo-([0-9]+)-(.*?)(c_action=edit\&amp\;comment_id=[0-9]+\#edit_comment)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?photo_id=$2&$4'", $output);
$pattern = "/'([^\']+)Photo-([0-9]+)-(.*?)(c_action=delete\&amp\;comment_id=[0-9]+)'/i";
$output = preg_replace($pattern, "'".FUSION_SELF."?photo_id=$2&$4'", $output);

return $output;
}

// Main Handler for SEO URLs
add_handler("seo_url_handler");

}
?>