<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: SEO Friendly URLs for PHP-Fusion
| Filename: seo_friendly_urls_panel_admin.php
| Author: Ankur Thakur
| Version: 1.00
| Developers: Ankur Thakur
| Web : http://ankurthakur.co.cc/
|       http://php-fusion.in/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";
include LOCALE.LOCALESET."admin/settings.php";

if (!checkrights("JSN")||!defined("iAUTH")||$_GET['aid']!=iAUTH) { redirect("../index.php"); }

if (file_exists(INFUSIONS."seo_friendly_urls_panel/locale/".$settings['locale'].".php")) {
   include INFUSIONS."seo_friendly_urls_panel/locale/".$settings['locale'].".php";
     } else {
   include INFUSIONS."seo_friendly_urls_panel/locale/English.php"; 
}
include INFUSIONS."seo_friendly_urls_panel/infusion_db.php";
include INCLUDES."infusions_include.php";

$inf_folder = "seo_friendly_urls_panel";

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// Creating Info for Errors
if (isset($_GET['error']) && isnum($_GET['error'])) {
	if ($_GET['error'] == 1) {
		$message = $locale['901'];
	}
	else if ($_GET['error'] == '0') {
		$message = $locale['900'];
	}
	if (isset($message)) {
		echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; 
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// Infusion Settings Query
if (isset($_POST['saveinfusionsettings']))
{
	$error = 0;

	$result = set_setting("seo_urls_enabled", stripinput($_POST['enable_seo']), $inf_folder);
	if (!$result)	{	$error = 1;	}
	$result = set_setting("seo_urls_type", stripinput($_POST['seo_urls_type']), $inf_folder);
	if (!$result)	{	$error = 1;	}

	if ($error == 1)
	{
		redirect(FUSION_SELF.$aidlink."&error=1");
	}
	else {	redirect(FUSION_SELF.$aidlink."&error=0");	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

// Infusion Settings
opentable($locale['inf_admin_title']);

// Database Settings
// Fetching Database Settings
$seosettings = array();
$seosettings = get_settings($inf_folder);

// Check if User has changed the Homepage in Main Settings to some HTML file or not
if ($seosettings['seo_urls_type'] == "html")	{
	if (preg_match("/(.*)\.php/", $settings['opening_page'], $match))	{
		echo "<div class='admin-message'>".sprintf($locale['seo_admin_openingpagenotify'], $settings['opening_page'], $match[1].".html")."</div>\n";
	}
}
else	{
	if (preg_match("/(.*)\.php/", $settings['opening_page'], $match))	{
		echo "<div class='admin-message'>".sprintf($locale['seo_admin_openingpagenotify'], $settings['opening_page'], $match[1])."</div>\n";
	}
	else if (preg_match("/(.*)\.html/", $settings['opening_page'], $match))	{
		echo "<div class='admin-message'>".sprintf($locale['seo_admin_openingpagenotify'], $settings['opening_page'], $match[1])."</div>\n";
	}
}

echo "<form name='infusion_settings' method='post' action='".FUSION_SELF.$aidlink."'>\n";
echo "<table cellpadding='0' cellspacing='0' align='center'>\n";

//-------------------- Main Settings --------------------//

echo "<tr>\n";
echo "<td class='tbl2'><b>".$locale['seo_admin_mainset']."</b></td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "<td class='tbl2'>".$locale['seo_admin_001']." :</td>\n";
echo "<td class='tbl2'>";
echo "<select name='enable_seo' class='textbox'>";
echo "<option value='0'".($seosettings['seo_urls_enabled'] == 0 ? "selected='selected'" : "").">".$locale['seo_admin_no']."</option>\n";
echo "<option value='1'".($seosettings['seo_urls_enabled'] == 1 ? "selected='selected'" : "").">".$locale['seo_admin_yes']."</option>\n";
echo "</select>";
echo "</td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "<td class='tbl2'>".$locale['seo_admin_002']." :</td>\n";
echo "<td class='tbl2'>";
echo "<select name='seo_urls_type' class='textbox'>";
echo "<option value='html'".($seosettings['seo_urls_type'] == "html" ? "selected='selected'" : "").">".$locale['seo_admin_002a'].": ".$settings['siteurl']."News.html</option>\n";
echo "<option value='plain'".($seosettings['seo_urls_type'] == "plain" ? "selected='selected'" : "").">".$locale['seo_admin_002b'].": ".$settings['siteurl']."News</option>\n";
echo "</select>";
echo "</td>\n";
echo "</tr>\n";

echo "<tr>\n";
echo "<td class='tbl2'></td>\n";
echo "<td class='tbl2'><input type='submit' name='saveinfusionsettings' value='".$locale['seo_admin_save']."' class='button' /></td>\n";
echo "</tr>\n";

echo "</table>\n</form>\n";
closetable();

require_once THEMES."templates/footer.php";
?>